#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>
#include <inttypes.h>

#include "parapin.h"

void waittime()
{
    struct timeval tv1, tv2;
    double t1, t2, tdiff;

    gettimeofday( &tv1, NULL );
    t1 = tv1.tv_usec;
    t1 /= 1000000;
    t1 += tv1.tv_sec;
    do {
        gettimeofday( &tv2, NULL );
        t2 = tv2.tv_usec;
        t2 /= 1000000;
        t2 += tv2.tv_sec;
        tdiff = t2 - t1;
    } while ( tdiff < 0.01 );
}

uint8_t readBit()
{
    short old_val = -1, new_val, pre_val, want_send;

    for (;;) {
        old_val = pin_is_set(LP_PIN[11]);
        set_pin( LP_PIN02 );
        new_val = pin_is_set(LP_PIN[11]);

        if ( old_val != new_val ) {
            printf( "Race condition 1\n");
        }

        pre_val = new_val;

        waittime();

        old_val = pin_is_set(LP_PIN[11]);
        clear_pin( LP_PIN02 );
        new_val = pin_is_set(LP_PIN[11]);

        if ( old_val != new_val ) {
            printf( "Race condition 2\n");
        }

        if ( pre_val != new_val ) {
            want_send = 1;
        } else {
            want_send = 0;
        }

        pre_val = new_val;

        waittime();

        new_val = pin_is_set(LP_PIN[11]);

        if ( want_send == 1 ) {
            //printf( "Send bit %d\n", ( pre_val != new_val ) ? 1 : 0 );
            return ( pre_val != new_val ) ? 1 : 0;
        } else {
            //printf( "uC didn't want to send a bit\n" );
        }
    }
}

uint16_t readValue()
{
    int state = 0;
    uint16_t v = 0;

    for (;;) {
        uint8_t b = readBit();

        if ( state == 0 ) {
            if ( b == 1 ) state = 1;
        } else if ( state >= 1 && state <= 16 ) {
            if ( b != 0 ) {
                state = 0;
                printf( "Reset state 1\n" );
            }
            state++;
        } else if ( state == 17 ) {
            if ( b != 1 ) {
                state = 0;
                printf( "Reset state 2\n" );
            }
            state++;
        } else if ( state == 18 ) {
            if ( b != 1 ) {
                state = 0;
                printf( "Reset state 3\n" );
            }
            state++;
        } else if ( state >= 19 && state <= 34 ) {
            v >>= 1;

            if ( b == 1 ) {
                v |= 1 << 15;
            }

            state++;
        } else if ( state == 35 ) {
            if ( b != 1 ) {
                state = 0;
                printf( "Reset state 4\n" );
            }
            //printf( "Got value %u\n", v );
            return v - 1;
        }
    }
}

int main( int argc, char **argv )
{
    int c = 0;
    
    if (pin_init_user(LPT1) < 0)
        exit(0);
    
    pin_output_mode(LP_DATA_PINS);
    pin_input_mode(LP_SWITCHABLE_PINS);
    
    //set_pin( LP_PIN02 );
    clear_pin( LP_PIN02 );
    
    printf("starting\n");
    for (;;) {
        uint16_t v = readValue();

        printf( "Got value %d: %u\n", c++, v );
    }
    printf("\n\n");
    return 0;
}
